#ifndef __TUM3D_CUDACOMPRESS__ENCODE_H__
#define __TUM3D_CUDACOMPRESS__ENCODE_H__


#include "global.h"

#include "tools/BitStream.h"

#include "EncodeCommon.h"


namespace cudaCompress {

class Instance;


size_t encodeGetRequiredMemory(const Instance* pInstance);
bool encodeInit(Instance* pInstance);
bool encodeShutdown(Instance* pInstance);

// note: all decode* functions assume that the bitstream memory is already page-locked; performace will degrade slightly if it isn't

bool encodeRLHuff(Instance* pInstance, BitStream* ppBitStreams[], bool singleBitStream, const Symbol* const pdpSymbolStreams[], uint blockCount, uint symbolCountPerBlock);
bool decodeRLHuff(Instance* pInstance, BitStreamReadOnly* ppBitStreams[], bool singleBitStream, Symbol* pdpSymbolStreams[], uint blockCount, uint symbolCountPerBlock);

bool encodeHuff(Instance* pInstance, BitStream* ppBitStreams[], bool singleBitStream, /*const*/ Symbol* const pdpSymbolStreams[], uint blockCount, uint symbolCountPerBlock);
bool decodeHuff(Instance* pInstance, BitStreamReadOnly* ppBitStreams[], bool singleBitStream, Symbol* pdpSymbolStreams[], uint blockCount, uint symbolCountPerBlock);

//void encodeResetBitCounts();
//void encodePrintBitCounts();

}


#endif
