#ifndef __TUM3D_CUDACOMPRESS__ENCODE_COMMON_H__
#define __TUM3D_CUDACOMPRESS__ENCODE_COMMON_H__


#include "global.h"


namespace cudaCompress {

typedef ushort Symbol;
const Symbol INVALID_SYMBOL = ushort(-1);

const uint LOG2_MAX_SYMBOL_BITS = 4;
const uint MAX_SYMBOL_BITS = (1 << LOG2_MAX_SYMBOL_BITS); // = sizeof(Symbol) * 8
static_assert(MAX_SYMBOL_BITS == sizeof(Symbol) * 8, "Inconsistent constants: MAX_SYMBOL_BITS is not equal to sizeof(Symbol) * 8");

const uint LOG2_MAX_CODEWORD_BITS = 5;
const uint MAX_CODEWORD_BITS = (1 << LOG2_MAX_CODEWORD_BITS);

const uint LOG2_HUFFMAN_LOOKUP_SIZE = 7;
const uint HUFFMAN_LOOKUP_SIZE = (1 << LOG2_HUFFMAN_LOOKUP_SIZE);

const uint LOG2_MAX_DISTINCT_SYMBOLS = 14;
const uint MAX_DISTINCT_SYMBOLS = (1 << LOG2_MAX_DISTINCT_SYMBOLS);


const uint ZERO_COUNT_MAX = 255;

}


#endif
