#ifndef __TUM3D_CUDACOMPRESS__HUFFMAN_H__
#define __TUM3D_CUDACOMPRESS__HUFFMAN_H__


#include "global.h"

#include "EncodeCommon.h"


namespace cudaCompress {

class Instance;


//TODO make separate versions for encoder and decoder?
struct HuffmanGPUStreamInfo
{
	// raw data
	Symbol* dpSymbolStream;
	// encoder info
	uint* dpEncodeCodeWords;
	uint* dpEncodeCodeWordLengths;

	// encoded data
	uint* dpCodewordStream;
	uint* dpOffsets;
	// decoder info
	byte* dpDecodeTable;
	uint decodeSymbolTableSize;

	uint symbolCount;
};


size_t huffmanGetRequiredMemory(const Instance* pInstance);
bool huffmanInit(Instance* pInstance);
bool huffmanShutdown(Instance* pInstance);

// note: offsetInterval has to be a power of 2 between 32 and 256
// note: huffmanDecode does *not* sync on the upload  of pStreamInfos to complete!!
bool huffmanEncode(Instance* pInstance, const HuffmanGPUStreamInfo* pStreamInfos, uint streamCount, uint offsetInterval, uint* pCompressedSizeBits);
bool huffmanDecode(Instance* pInstance, const HuffmanGPUStreamInfo* pStreamInfosPinned, uint streamCount, uint offsetInterval);

}


#endif
