#include "Init.h"

#include "Instance.h"


namespace cudaCompress {

void* createInstance(int cudaDevice, uint sizeMaxX, uint sizeMaxY, uint sizeMaxZ, uint channelCountMax, uint offsetIntervalMin)
{
	Instance* pInstance = new Instance();
	if(pInstance->create(cudaDevice, sizeMaxX, sizeMaxY, sizeMaxZ, channelCountMax, offsetIntervalMin)) {
		return pInstance;
	} else {
		delete pInstance;
		return nullptr;
	}
}

void destroyInstance(void* pInstance)
{
	if(pInstance == nullptr) return;

	Instance* pInst = (Instance*)pInstance;
	pInst->destroy();
	delete pInst;
}

}
